using HKCardOUT.Helper;
using Logic.RemoteModel;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Markup;
using UHFHelper;
using XExten.Advance.HttpFramework.MultiCommon;
using XExten.Advance.HttpFramework.MultiFactory;
using XExten.Advance.LinqFramework;

namespace HKCardOUT.Logic
{
    public class RemoteService
    {
        /// <summary>
        /// 判断卡状态
        /// </summary>
        /// <param name="input"></param>
        public static int CheckCardStuatas(string CardNo)
        {
            var data = IHttpMultiClient.HttpMulti.AddNode(t =>
              {
                  t.NodePath = ApiRoute.CheckCardStatus;
                  t.ReqType = MultiType.POST;
                  t.JsonParam = (new { cardNum = CardNo }).ToJson();
              }).Build().RunStringFirst().ToModel<JObject>()["data"]["cardState"];
            return data != null ? data.ToString().AsInt() : 0;
        }
        /// <summary>
        /// 同步消费记录
        /// </summary>
        /// <param name="CardNo"></param>
        /// <param name="Money"></param>
        public static bool SyncSaleLog(string CardNo, string StallId)
        {
            var GateId = DataBus.StoreInfo.Devices.FirstOrDefault(t => t.Address.AsInt() == StallId.AsInt())?.GateId;
            var data = IHttpMultiClient.HttpMulti.AddNode(t =>
              {
                  t.ReqType = MultiType.POST;
                  t.JsonParam = (new { GateId = GateId, Type = -1, CardNum = CardNo }).ToJson();
                  t.NodePath = ApiRoute.SyncSaleLog;
              }).Build().RunStringFirst();
            HKLog.HKLogImport.WriteInfo($"同步消费时候调用：{data}");
            var m = bool.Parse(data.ToModel<JObject>()["data"].ToString());
            if (m)
            {
                UHF_RS485_Helper.GetInstance().OpenBeep(StallId.AsInt());
                return m;
            }
            else return false;
        }
        /// <summary>
        /// 获取店铺信息
        /// </summary>
        public static void PullShopInfo()
        {
            var data = IHttpMultiClient.HttpMulti.AddNode(t =>
             {
                 t.NodePath = ApiRoute.PullShopInfo;
             }).Build().RunStringFirst()
             .ToModel<JObject>()["data"].ToJson().ToModel<StoreInfoResponse>();
            DataBus.StoreInfo = data;
        }
    }
}
